using System;
using System.Linq;
using Microsoft.VisualStudio.ExtensionsExplorer;

namespace VsxFactory.ExtensionManager.Providers {

    /// <summary>
    /// This tree node simply shows no packages.
    /// </summary>
    internal class EmptyTreeNode : PackagesTreeNodeBase {

         private readonly string _category;

        public EmptyTreeNode(PackagesProviderBase provider, string category, IVsExtensionsTreeNode parent) : 
            base(parent, provider, null) {

            if (category == null) {
                throw new ArgumentNullException("category");
            }

            _category = category;
        }

        public override string Name {
            get {
                return _category;
            }
        }

        public override IQueryable<DataServicePackage> GetPackages()
        {
            return Enumerable.Empty<DataServicePackage>().AsQueryable();
        }
    }
}
