﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics.CodeAnalysis;

namespace VsxFactory.ExtensionManager
{
    public class PackageComparer : IComparer<DataServicePackage>
    {
        [SuppressMessage("Microsoft.Security", "CA2104:DoNotDeclareReadOnlyMutableReferenceTypes", Justification = "This type isn't mutable")]
        public static readonly PackageComparer Version = new PackageComparer((x, y) => x.Version.CompareTo(y.Version));

        private readonly Func<DataServicePackage, DataServicePackage, int> _compareTo;
        private PackageComparer(Func<DataServicePackage, DataServicePackage, int> compareTo)
        {
            _compareTo = compareTo;
        }

        public int Compare(DataServicePackage x, DataServicePackage y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null)
            {
                return -1;
            }
            if (y == null)
            {
                return 1;
            }
            return _compareTo(x, y);
        }
    }
}
